k_cos.c File Reference
`#include "math_libm.h"`
`#include "math_private.h"`
Include dependency graph for k_cos.c:

Go to the source code of this file.

## Functions

double attribute_hidden | __kernel_cos (double x, double y)

## Variables

static const double | one = 1.00000000000000000000e+00
static const double | C1 = 4.16666666666666019037e-02
static const double | C2 = -1.38888888888741095749e-03
static const double | C3 = 2.48015872894767294178e-05
static const double | C4 = -2.75573143513906633035e-07
static const double | C5 = 2.08757232129817482790e-09
static const double | C6 = -1.13596475577881948265e-11

## Function Documentation

## __kernel_cos()

double attribute_hidden __kernel_cos | ( | double | x,
|  | double | y
| ) |  |

Definition at line 59 of file k_cos.c.

{
double a,hz,z,r,qx;
int32_t ix;
GET_HIGH_WORD(ix,x);
ix &= 0x7fffffff; /* ix = |x|'s high word*/
if(ix<0x3e400000) { /* if x < 2**27 */
if(((int)x)==0) return one; /* generate inexact */
}
z = x*x;
r = z*(C1+z*(C2+z*(C3+z*(C4+z*(C5+z*C6)))));
if(ix < 0x3FD33333) /* if |x| < 0.3 */
return one - (0.5*z - (z*r - x*y));
else {
if(ix > 0x3fe90000) { /* x > 0.78125 */
qx = 0.28125;
} else {
INSERT_WORDS(qx,ix-0x00200000,0); /* x/4 */
}
hz = 0.5*z-qx;
a = one-qx;
return a - (hz - (z*r-x*y));
}
}

References C1, C2, C3, C4, C5, C6, GET_HIGH_WORD, INSERT_WORDS, and one.

Referenced by cos(), and sin().

## Variable Documentation

## C1

const double C1 = 4.16666666666666019037e-02

static

Definition at line 52 of file k_cos.c.

Referenced by __kernel_cos().

## C2

const double C2 = -1.38888888888741095749e-03

static

Definition at line 53 of file k_cos.c.

Referenced by __kernel_cos().

## C3

const double C3 = 2.48015872894767294178e-05

static

Definition at line 54 of file k_cos.c.

Referenced by __kernel_cos().

## C4

const double C4 = -2.75573143513906633035e-07

static

Definition at line 55 of file k_cos.c.

Referenced by __kernel_cos().

## C5

const double C5 = 2.08757232129817482790e-09

static

Definition at line 56 of file k_cos.c.

Referenced by __kernel_cos().

## C6

const double C6 = -1.13596475577881948265e-11

static

Definition at line 57 of file k_cos.c.

Referenced by __kernel_cos().

## one

const double one = 1.00000000000000000000e+00

static

Definition at line 51 of file k_cos.c.

Referenced by __kernel_cos().

C3
static const double C3
Definition: k_cos.c:54
r
GLdouble GLdouble GLdouble r
Definition: SDL_opengl.h:2079
z
GLdouble GLdouble z
Definition: SDL_opengl_glext.h:404
a
GLboolean GLboolean GLboolean GLboolean a
Definition: SDL_opengl_glext.h:1109
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1574
int32_t
signed int int32_t
Definition: SDL_config_windows.h:62
INSERT_WORDS
#define INSERT_WORDS(d, ix0, ix1)
Definition: math_private.h:127
C6
static const double C6
Definition: k_cos.c:57
C1
static const double C1
Definition: k_cos.c:52
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1574
C2
static const double C2
Definition: k_cos.c:53
C4
static const double C4
Definition: k_cos.c:55
GET_HIGH_WORD
#define GET_HIGH_WORD(i, d)
Definition: math_private.h:109
one
static const double one
Definition: k_cos.c:51
C5
static const double C5
Definition: k_cos.c:56